// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_STRING_CSTRING_H
#define FENNEC_TEST_STRING_CSTRING_H

#include "../../test.h"

#include <fennec/string/cstring.h>

namespace fennec::test
{

	inline void fennec_test_STRING_cstring()
	{
		static       char test_string[]       = "Hello World!";
		static const char test_string_const[] = "Hello World!";

		cstring str  = test_string;
		const cstring cstr = test_string_const;

		fennec_test_run(str, cstr);
		fennec_test_run(cstr, str);

		fennec_test_spacer(1);

		fennec_test_run(str.length(),       static_cast<size_t>(12));
		fennec_test_run(str.compare(cstr),  0);
		fennec_test_run(str.find('W'),      static_cast<size_t>(6));
		fennec_test_run(str.find("World"),  static_cast<size_t>(6));
		fennec_test_run(str.rfind('o'),     static_cast<size_t>(7));
		fennec_test_run(str.rfind("World"), static_cast<size_t>(6));
	}

}

#endif // FENNEC_TEST_STRING_CSTRING_H
